package tuitate_4_1_4;

//
// class Board : סȤΤƤ륯饹
//
public class Board extends PieceKind
{
  // ׾ˤ륳ޤξ
  int id[][]= new int[10][9];
  
  // ޤξ
  Piece piece[] = new Piece[41];
  
  // mySide  GameData 饹
  
  // 餺ե饰,(ʬؤƤ)ե饰
  int promote;
  boolean checked;
  
  // ξ
  int capPiece[] = new int[20];
  
  // ʬڤȿ§Ĥ
  int myLife,enemyLife;
  
  // ưǤ뤫ɤ (0 : Բ, 1 : ǽ, 
  //                     2 : , 3 : 뤷ʤ)
  int moveThere;

  // ΰ֤˰ưǽɤ (0 : Բ, 1 : ǽ,
  //                             2 : , 3 : 뤷ʤ)
  int moveTo[][] = new int[9][9];

//
// 󥹥ȥ饯
//
  public Board()
  {
    // פν
    for(int i=0;i<10;i++)
      for(int j=0;j<9;j++)
        id[i][j] = 0;
    
    // 򸵤ν
    int pieceX[]    = { 0,0,1,2,3,4,5,6,7,8,0,8,1,7,2,6,3,5,1,7,4};
    int pieceY[]    = { 0,6,6,6,6,6,6,6,6,6,8,8,8,8,8,8,8,8,7,7,8};
    int pieceKind[] = {-1,1,1,1,1,1,1,1,1,1,2,2,3,3,4,4,5,5,6,7,8};
    
    piece[0] = new Piece();
    for(int i=1;i<21;i++)
    {
      piece[i] = new Piece(pieceX[i],pieceY[i],pieceKind[i]);
      id[piece[i].x][piece[i].y] = i;
    }
    
    // ζ?ν
    for(int i=21;i<41;i++)
      piece[i] = new Piece();
    
    // ȿ§λĤ,餺ե饰,ե饰 
    myLife = 8;
    enemyLife = 8;
    promote = 0;
    checked = false;
    
    // 
    for(int i=0;i<20;i++)
    {
      capPiece[i] = 0;
    }
  }

//
// getPieceKind : ڤ ID μޤμ֤
//
  public int getPieceKind(Tpoint pt)
  {
    if(pt.group == 0)
      return(getPieceKind(pt.x,pt.y));
    if(pt.group == 1)
      return(pt.y + 1);
    return(-1);
  }
  
  public int getPieceKind(int _x,int _y)
  {
    if(_x >= 0 && _x < 9 && _y >= 0 && _y < 9)
      return(piece[id[_x][_y]].kind);
    else
      return(-1);
  }
  
  public int getPieceKind(int cId)
  {
    return(piece[cId].kind);
  }


//
// setPieceKind : ID μޤμꤹ
//
  public void setPieceKind(int cId,int newKind)
  {
    piece[cId].kind = newKind;
  }


//
// getPieceId : μޤID֤
//
  public int getPieceId(Tpoint pt)
  {
    if(pt.group == 0)
      if(pt.x >= 0 && pt.x < 9 && pt.y >= 0 && pt.y < 9)
        return(id[pt.x][pt.y]);
    if(pt.group == 1)
      return(id[9][pt.y]);
    return(-1);
  }


//
// setPieceId : μޤIDꤹ
//
  public void setPieceId(Tpoint pt,int sId)
  {
    if(pt.group == 0)
      setPieceId(pt.x,pt.y,sId);
    if(pt.group == 1)
      setPieceId(9,pt.y,sId);
  }

  public void setPieceId(int _x,int _y,int sId)
  {
    id[_x][_y] = sId;
  }


//
// getNextPieceId : λޤID֤
//
  public int getNextPieceId(int searchKind)
  {
    for(int i = 1;i < 41;i++)
    {
      // õƤ륳ޤޤǡļबξ礽 ID ֤
      if(piece[i].x == 9 && piece[i].kind == searchKind)
        return(i);
    }
    
    // ¸ߤʤä
    return(-1);
  }


//
// moveCheck : ޤưǽɤå
//
  public int moveCheck(int cId,Tpoint from,Tpoint to)
  {
    // ư褬ϰϳ
    if(from.group == -1 || to.group == -1)
      return(0);

    return(moveCheck(cId,from.group * 9 + from.x,from.y,
                     to.group * 9 + to.x,to.y));
  }
  
  public int moveCheck(int cId,int fromX,int fromY,int toX,int toY)
  {
    // ޤ x = 9 ȹͤ (Τ version ̾Ĥ)

    // ưΥ(Ȥ)
    int dx,dy,dist;
    int absDx,absDy;
    int kind = piece[cId].kind;

    //    System.out.println("MoveCheck ID:"+cId+" Kind:"+kind+" fromX:"+fromX+" fromY:"+fromY+
    //                                         " toX:"+toX+" toY:"+toY);
    
    // ֤ˤϤưǤʤ
    if(toX == 9)
      return(0);

    // ޤ֤
    if(fromX == 9)
    {
      // Υå
      if(kind == PAWN)
      {
        for(int y=0;y<9;y++)
          if(getPieceKind(toX,y) == PAWN)
            return(0);
      }
      
      // ưʤˤ֤ʤ
      if(((kind == PAWN || kind == LANCE) && toY == 0) ||
          (kind == KNIGHT && (toY == 0 || toY == 1)))
        return(0);
      
      return(1);
    }

    dx = toX - fromX;
    dy = toY - fromY;
    
    // Math.abs ϻȤäƤʤ
    if(dx < 0)
      absDx = -dx;
    else 
      absDx = dx;
    
    if(dy < 0)
      absDy = -dy;
    else
      absDy = dy;
    
    if(absDx > absDy)
      dist = absDx;
    else
      dist = absDy;

    // ޤμˤäʬ
    switch(kind % 16)
    {

      // ʼ
      case PAWN:
        if(dx == 0 && dy == -1)
        {
          // 
          if(toY == 1 || toY == 2)
            return(2);
          // 뤷ʤ
          if(toY == 0)
            return(3);
          return(1);
        }
        else
          return(0);

      // 
      case LANCE:
        if(dx == 0 && dy < 0)
        {
          // ˥ޤ뤫
          for(int y = toY + 1;y < fromY;y++)
            if(id[toX][y] != 0)
              return(0);
          // 
          if(toY == 1 || toY == 2)
            return(2);
          // 뤷ʤ
          if(toY == 0)
            return(3);
          return(1);
        }
        else
          return(0);

      // 
      case KNIGHT:
        if(dy == -2 && (dx == 1 || dx == -1))
        {
          // 
          if(toY == 2)
            return(2);
          // 뤷ʤ
          if(toY == 1 || toY == 0)
            return(3);
          return(1);
        }
        else
          return(0);

      // 侭
      case SILVER:
        if(dist == 1 && (dy == -1 || absDx == absDy))
        {
          if(toY < 3 || fromY == 2)
            return(2);
          return(1);
        }
        else
          return(0);

      // ⾭,ȶ,,,
      case GOLD:
      case PROM_PAWN:
      case PROM_LANCE:
      case PROM_KNIGHT:
      case PROM_SILVER:
        if(dist == 1 && (dy == -1 || dy == 0 || dx == 0))
          return(1);
        else
          return(0);

      // ѹ,,ζ,ε
      case BISHOP:
      case ROOK:
      case PROM_BISHOP:
      case PROM_ROOK:
        if(dist == 0 || !((kind % 8 == BISHOP && absDx == absDy) ||
                          (kind % 8 == ROOK && (dx == 0 || dy == 0)) ||
                          ((kind % 16 == PROM_BISHOP || kind % 16 == PROM_ROOK)
                             && dist == 1) ) )
          return(0);
        else
        {
          if(absDx == 0)
            absDx = 1;
          if(absDy == 0)
            absDy = 1;
          
          // ʹ*̣*ޤпʤʤ
          for(int i=1;i<dist;i++)
          {
            int tmpKind = piece[id[fromX+dx/absDx*i][fromY+dy/absDy*i]].kind - 
                          (kind / 16)*16;
            if(tmpKind > 0 && tmpKind < 16)
              return(0);
          }
          // 
          if((kind % 16)/ 8 == 0 && (toY < 3 || fromY < 3))
            return(2);
          return(1);
        }

      // (̾)
      case KING:
        if(dist == 1)
          return(1);
        else
          return(0);

      // ¾(ʻ̵Ϥ)
      default:
        return(0);

    }
  }

//
// reverse : ̤ȥޤξž̤
//
  public Board reverse()
  {
    Board rBoard = new Board();

    for(int y=0;y<9;y++)
    {
      for(int x=0;x<9;x++)
        rBoard.id[x][y] = this.id[8-x][8-y];
      rBoard.id[9][y] = this.id[9][y];
    }
    
    rBoard.piece = this.piece;
    
    return(rBoard);
  }

}


//
// class PieceKind : ޤμ򼨤饹
//
class PieceKind
{
  public final int DUMMY = 0;
  public final int PAWN = 1;
  public final int LANCE = 2;
  public final int KNIGHT = 3;
  public final int SILVER = 4;
  public final int GOLD = 5;
  public final int BISHOP = 6;
  public final int ROOK = 7;
  public final int KING = 8;
  public final int PROM_PAWN = 9;
  public final int PROM_LANCE = 10;
  public final int PROM_KNIGHT = 11;
  public final int PROM_SILVER = 12;
  public final int PROM_GOLD = 13;    
  public final int PROM_BISHOP = 14;
  public final int PROM_ROOK = 15;

  static final String PIECENAME[] = {"DUMMY","PAWN","LANCE","KNIGHT","SILVER",
                   "GOLD","BISHOP","ROOK","KING","PROM_PAWN","PROM_LANCE",
                   "PROM_LANCE","PROM_KNIGHT","PROM_SILVER",
                   "PROM_GOLD?","PROM_BISHOP","PROM_ROOK"};
}
