package tuitate_4_1_4;

import java.io.*;
import java.lang.*;
import java.net.*;

//
// class Connection : ФȤ³ô륯饹
//
public class Connection
{
  // å
  Socket soc;
  
  // ǡϥȥ꡼
  DataInputStream dataIn;
  DataOutputStream dataOut;
  
  // Ф̾ȥݡֹ
  String serverName;
  int port;
  
  // 
  Logger log;
  
  // ³Ƥ뤫
  boolean isOpen;
  // Ԥ֤
  boolean isWaiting;  
  
//
// 󥹥ȥ饯
//
  public Connection(String servername,int port,Logger l)
  {
    this.serverName = servername;
    this.port = port;
    log = l;
    isOpen = false;
  }


//
// open : Ф³
//
  public boolean open()
  {
    boolean openSts = true;
    isOpen = false;
    
    try
    {
      log.write("Connecting to server (" + serverName +","+
                 Integer.toString(port)+")");
      // åȤ򳫤
      soc = new Socket(serverName,port);
      // ȥ꡼μ
      dataIn  = new DataInputStream(
             new BufferedInputStream( soc.getInputStream() ) );
      dataOut = new DataOutputStream(
             new BufferedOutputStream(soc.getOutputStream()) );
    } catch ( Exception e ) {
      // ³Ԥξ
      log.write("Couldn't connect to server");
      e.printStackTrace();
      openSts = false;
    }
    isOpen = openSts;
    
    return(isOpen);
  }


//
// reopen : ФȤ³Ǥ⤦³
//
  public void reopen()
  {
    close();
    open();
  }


//
// close : ФȤ³ȯŪڤ
//
  public void close()
  {
    if(soc != null && isOpen)
    {
      sendMessage("QUIT");
      
      try {
        // åȤĤ
        soc.close();
        log.write("Close connection");
        soc = null;
      } catch ( Exception e ) {
        e.printStackTrace();
        return;
      }
    }

    shut();
  }


//
// shut : ФȤ³ڤ줿ν
//
  public void shut()
  {
    isOpen = false;
    dataIn = null;
    dataOut = null;
  } 

//
// sendMessage : Ф˥å
//
  public void sendMessage(String message)
  {
    log.write("Send Message : "+ message);
    try {
      dataOut.writeBytes(message + '\n');
      dataOut.flush();
    } catch (Exception e) {
      e.printStackTrace();
      return;
    }
    return;
  }



//
// waitMessage : Фå
//
  public String waitMessage()
  {
    String recvMsg;

    // åμ
    try {
      recvMsg = dataIn.readLine();
    } catch (Exception e) {
      e.printStackTrace();
      return(null);
    }
    log.write("Recv message : "+ recvMsg);
    
    return(recvMsg);
  }

//
// flushMessages : ФƤåƾõ
//
  public void flushMessages()
  {
    start();
    
    while(true)
    {
      if(!isOpen)
        break;
      
      int getOk = 0;
      try {
        getOk = dataIn.available();
      } catch(IOException e) {
        getOk = 0;
      }
      
      if(getOk != 0)
      {
        // åνλ"." ޤǥåΤƤƤ
        if(waitMessage().equals("."))
          break;
      }
    }
    shut();
  }

//
// stop : ³Ūߤ
//
  public void stop()
  {
    isWaiting = true;
  }

//
// start : ³Ƴ
//
  public void start()
  {
    isWaiting = false;
  }
}
