package tuitate_4_1_4;

import java.awt.*;

//
// class Cursor : ϢΥ饹
//
public class Cursor
{
  // κɸ
  Tpoint curr,prev;
  
  // ܥν
  public final int GROUPS = 5;
  ButtonGroup btnGrp[] = new ButtonGroup[GROUPS];
  
  // ¸
  Tpoint from,to;
  int checkedId;
  boolean pieceChecked;
  
  // ߤΥξ
  int mode;
  
  // ܥ󤬲뤫
  boolean mouseOk;
  
  
//
// 󥹥ȥ饯
//
  public Cursor()
  {
    mouseOk = false;
    mode = 0;
    curr = new Tpoint();
    prev = new Tpoint();
    from = new Tpoint();
    to = new Tpoint();
    reset();
  }


//
// back , set : ᤷʤ᤿ꤹ
//
  public void back()
  {
    curr.set(prev);
  }
  
  public void set()
  {
    prev.set(curr);
  }


//
// moved : 뤬ưȽꤹ
//
  public boolean moved()
  {
    return(!(curr.isEqual(prev))); 
  }


//
// move : ư
//
  public void move(Graphics g)
  {
    if(prev.group != -1)
      btnGrp[prev.group].erase(prev,g,pieceChecked);
    draw(g);
    
    set();
  }


//
// newBtnGrp : ܥ󷲤
//
  public void newBtnGrp(int gameMode)
  {
    int bg[][][] ={{{125,415,2,3,150,20,0},{550,350,1,2,70,25,0},
                    {0,0,0,0,0,0,0},{0,0,0,0,0,0,0},{0,0,0,0,0,0,0}},
                   {{125,415,2,3,150,20,0},{20,40,2,6,300,50,1},
                    {20,5,3,2,50,15,0},{550,350,1,2,70,25,0},
                    {170,5,1,1,30,30,0}},
                   {{125,415,2,3,150,20,0},{20,40,2,2,300,100,1},
                    {20,5,3,2,50,15,0},{550,350,1,2,70,25,0},
                    {170,5,1,1,30,30,0}},
                   {{125,415,2,3,150,20,0},{20,40,2,2,300,150,1},
                    {20,5,3,2,50,15,0},{550,350,1,2,70,25,0},
                    {170,5,1,1,30,30,0}},
                   {{30,30,9,9,40,40,2},{430,110,1,7,40,40,3},
                    {500,250,1,3,100,50,0},
                    {520,420,1,2,70,25,0},{605,425,1,1,30,50,0}},
                   {{570,230,1,7,60,25,0},{555,417,1,2,70,25,0},
                    {0,0,0,0,0,0,0},{0,0,0,0,0,0,0},{0,0,0,0,0,0,0}}};
    
    for(int i=0;i<GROUPS;i++)
      btnGrp[i] = new ButtonGroup(bg[gameMode][i][0],bg[gameMode][i][1],
                                  bg[gameMode][i][2]*bg[gameMode][i][4],
                                  bg[gameMode][i][3]*bg[gameMode][i][5],
                                  bg[gameMode][i][4],bg[gameMode][i][5],
                                  bg[gameMode][i][6]);
    
    mode = 0;
  }


//
// erase : õ
//
  public void erase(Graphics g)
  {
    if(curr.group != -1)
      btnGrp[curr.group].erase(curr,g,pieceChecked);
  }

//
// draw : 褹
//
  public void draw(Graphics g)
  {
    if(curr.group != -1)
      btnGrp[curr.group].draw(curr,g,pieceChecked);
  }



//
// reset : ֤
//
  public void reset()
  {
    curr.group = -1;
    prev.group = -1;
  }



//
// drag : ׾Υޤ򤹤
//
  public void drag(Graphics g,int id,Image img,int restPiece,int moveTo[][])
  {
    set();

    from.set(curr);
    
    // ξõ
    erase(g);
    
    btnGrp[0].cursorImg = img;
    btnGrp[1].cursorImg = img;
    checkedId = id;
    pieceChecked = true;
    
    // ˤ
    if(curr.group == 0)
      g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
                 -Screen.BLANK_X+Screen.BOARD_X+curr.x*40,
                 -Screen.BLANK_Y+Screen.BOARD_Y+curr.y*40);
    
    // 
    if(curr.group == 1)
      // Ĥꥳޤʤ
      if(restPiece == 1)
      {
        g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
                   -Screen.BLANK_X+Screen.CAP_X,
                   -Screen.BLANK_Y+Screen.CAP_Y+curr.y*40);
        g.setColor(Color.black);
        g.fillRect(Screen.CAP_X-20,Screen.CAP_Y+curr.y*40,14,40);
      }
      // Ĥꥳޤ
      else
      {
        g.setColor(Color.black);
        g.fillRect(Screen.CAP_X-20,Screen.CAP_Y+curr.y*40,14,40);
        g.setColor(Color.yellow);
        g.setFont(new Font("Helvetica",Font.BOLD,13));
        g.drawString(restPiece-1 + " ",
                     Screen.CAP_X-20,Screen.CAP_Y+curr.y*40+40);
      }
    
    mode = 1;

    // ưǽΰɽ
    for(int y=0;y<9;y++)
      for(int x=0;x<9;x++)
	if(moveTo[x][y] != 0)
	  g.copyArea(Screen.GHILITE_X,Screen.GHILITE_Y,39,39,
                     -Screen.GHILITE_X+Screen.BOARD_X+x*40,
                     -Screen.GHILITE_Y+Screen.BOARD_Y+y*40);

	    
    // 
    draw(g);
  }


//
// failDrop : ޤΰư˼Ԥν
//
  public void failDrop(Graphics g,int restPiece,int moveTo[][])
  {
    erase(g);
    
    pieceChecked = false;
    
    if(from.group == 0)
    {
      g.drawImage(btnGrp[from.group].cursorImg,
                  from.x*40+Screen.BOARD_X,from.y*40+Screen.BOARD_Y,null);
    }
    if(from.group == 1)
    {
      g.drawImage(btnGrp[from.group].cursorImg,Screen.CAP_X,
		  from.y*40+Screen.CAP_Y,null);
      g.setColor(Color.black);
      g.fillRect(Screen.CAP_X-20,Screen.CAP_Y+from.y*40,14,40);
      g.setColor(Color.yellow);
      g.setFont(new Font("Helvetica",Font.BOLD,13));
      g.drawString(restPiece + " ",Screen.CAP_X-20,Screen.CAP_Y+from.y*40+40);
    }
    
    mode = 0;
    
    // ưǽΰä
    for(int y=0;y<9;y++)
      for(int x=0;x<9;x++)
	if(moveTo[x][y] != 0)
	  g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
                     -Screen.BLANK_X+Screen.BOARD_X+x*40,
                     -Screen.BLANK_Y+Screen.BOARD_Y+y*40);

    draw(g);
  }
  
  
//
// safeDrop : ޤΰưν
//
  public void safeDrop(Graphics g,int moveTo[][])
  {
    to.set(curr);
    
    erase(g);

    pieceChecked = false;

    // ưǽΰä
    for(int y=0;y<9;y++)
      for(int x=0;x<9;x++)
	if(moveTo[x][y] != 0)
	  g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
                     -Screen.BLANK_X+Screen.BOARD_X+x*40,
                     -Screen.BLANK_Y+Screen.BOARD_Y+y*40);

    g.drawImage(btnGrp[mode].cursorImg,curr.x*40+Screen.BOARD_X,
		curr.y*40+Screen.BOARD_Y,null);
    
    mode = 2;
    
    reset();
  }


//
// cancel : ޤ򸵤ΰ֤᤹
//
  public void cancel(Graphics g,int restPiece)
  {
    erase(g);
    
    g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
               -Screen.BLANK_X+Screen.BOARD_X+to.x*40,
               -Screen.BLANK_Y+Screen.BOARD_Y+to.y*40);
    
    if(from.group == 0)
    {
      g.drawImage(btnGrp[from.group].cursorImg,
                  from.x*40+Screen.BOARD_X,from.y*40+Screen.BOARD_Y,null);
    }
    if(from.group == 1)
    {
      g.drawImage(btnGrp[from.group].cursorImg,Screen.CAP_X,
                   from.y*40+Screen.CAP_Y,null);
      g.setColor(Color.black);
      g.fillRect(Screen.CAP_X-20,Screen.CAP_Y+from.y*40,14,40);
      g.setColor(Color.yellow);
      g.setFont(new Font("Helvetica",Font.BOLD,13));
      g.drawString(restPiece + " ",Screen.CAP_X-20,Screen.CAP_Y+from.y*40+40);
    }
    
    mode = 0;
    
    reset();
  }



//
// modeAndReset : ξ֤ѹƥꥻå
//
  public void modeAndReset(int toMode,Graphics g)
  {
    erase(g);
    mode = toMode;
    reset();
  } 


//
// point : ΰ֤
//
  public void point(int mouseX,int mouseY)
  {
    int i;
    
    for(i=0;i<GROUPS;i++)
    {
      Point location;
      location = btnGrp[i].inGroup(mouseX,mouseY);
      if(location.x == -1)
        continue;
      curr.x = location.x;
      curr.y = location.y;
      curr.group = i;
      break;
    }
    
    if(i == GROUPS)
      curr.group = -1;
  }


//
// possible : 뤬¸ߤ٤֤ɤĴ٤
//
  public boolean possible(int gameMode)
  {
    switch(gameMode * 10 + mode)
    {
      case 0:
        return(curr.group == 0);
      case 2:
        return(curr.group == 1);
      
      case 10:
      case 20:
      case 30:
        return((curr.group >= 0 && curr.group <= 2) || curr.group == 4);
      
      case 11:
      case 13:
      case 15:
      case 21:
      case 25:
      case 31:
      case 35:
        return(curr.group == 3);
      
      case 40:
        return(curr.group == 0 || curr.group == 1 || curr.group == 4);
      case 41:
        return(curr.group == 0 || curr.group == 1);
      case 42:
        return(curr.group == 2);
      case 43:
      case 44:
        return(curr.group == 4);
      case 45:
      case 46:
      case 48:
      case 49:
        return(curr.group == 3);
      
      case 50:
        return(curr.group == 0);
      case 51:
        return(curr.group == 1);
      
      // 1,12,14,16,22,23,24,32,33,34,47,52
      default:
        return false;
    }
  }  


//
// setX,setY,setGroup : ߤΥΰ֤ѹ
//
  public void setX(int _x)
  {
    curr.x = _x;
  }
  public void setY(int _y)
  {
    curr.y = _y;
  }
  public void setGroup(int _g)
  {
    curr.group = _g;
  }

//
// getX,getY,getGroup : ߤΥΰ֤򻲾Ȥ
//
  public int getX()
  {
    return(curr.x);
  }
  public int getY()
  {
    return(curr.y);
  }
  public int getGroup()
  {
    return(curr.group);
  }

}

