/*
 *  Mode 4 : GameMode                            01234
 *    mode 0 : ʬ֤̾ξ              oOxxo
 *    mode 1 : 򱿤Ǥ                OOxxx
 *    mode 2 : ؤγǧ                  xxoxx
 *    mode 3 : ФβԤ                  xxxxo
 *    mode 4 :                           xxxxo
 *    mode 5 : (֤̾)λ뤫ɤξxxxox
 *    mode 6 : Ƹ⡼ɤ򸫤뤫 (Y/N)    xxxox
 *    mode 7 : ---------------------
 *    mode 8 : (Ԥ)                    xxxox
 *    mode 9 : (֤)                    xxxox
 *  ButtonGroup 0 : 
 *              1 : ֤
 *              2 : ֻؤסס֤
 *              3 : Yes-No ܥ
 *              4 : λܥ
 */

package tuitate_4_1_4;

import java.awt.*;

//
// class GameMode : GAME ⡼ɤ
//
public class GameMode extends Mode
{
  
  //  (˴ؤǡ)
  Board board;
  
//
// 󥹥ȥ饯
//
  public GameMode(GameData _data,Graphics _g)
  {
    // ѡ饹Ʊ
    super(_data,_g);
  }
  
  
//
// init : 
//
  public void init()
  {
    // Version ɽ
    g.setColor(Color.yellow);
    g.setFont(new Font("Helvetica",Font.BOLD,13));
    g.drawString(data.version,560,60);
    
    // ʬξɽ
    g.setColor(Color.white);
    g.drawString(data.myName,580,591);
    g.copyArea(580,580,130,15,510-580,102-580);
    g.setColor(Color.black);
    g.fillRect(580,580,130,15);
    // ξɽ
    g.setColor(Color.white);
    g.drawString(data.checked.name1,580,591);
    g.copyArea(580,580,130,15,510-580,192-580);
    g.setColor(Color.black);
    g.fillRect(580,580,160,20);
    
    // 
    board = new Board();
    
    // ֶ̾פֲפ
    data.piece_g[8] = data.piece_g[0];
    
    // 
    if(data.mySide == 0)
    {
      data.cursor.modeAndReset(0,g);
      g.copyArea(0,481,370,38,50,-55);
    }
    else
    // 
    {
      data.cursor.modeAndReset(4,g);
      g.copyArea(0,519,370,19,50,-93);
      //   ,   ɽȿž롣
      for(int i=0;i<4;i++)
      {
        g.copyArea(Screen.BOARD_X+i*40,Screen.BOARD_Y-25,40,20,
		   640-Screen.BOARD_X-i*40,400-Screen.BOARD_Y+25);
        g.copyArea(Screen.BOARD_X+(8-i)*40,Screen.BOARD_Y-25,40,20,(i-4)*80,0);
        g.copyArea(640,400,40,20,
		   Screen.BOARD_X+(8-i)*40-640,Screen.BOARD_Y-25-400);

        g.copyArea(Screen.BOARD_X-25,Screen.BOARD_Y+i*40,20,40,
		   640-Screen.BOARD_X+25,400-Screen.BOARD_Y-i*40);
        g.copyArea(Screen.BOARD_X-25,Screen.BOARD_Y+(8-i)*40,20,40,
		   0,(i-4)*80);
        g.copyArea(640,400,20,40,
		   Screen.BOARD_X-25-640,Screen.BOARD_Y+(8-i)*40-400);
      }
    }
    
    // ޤ
    for(int i=1;i<21;i++)
    {
      g.drawImage(data.piece_g[board.piece[i].kind],
        board.piece[i].x*40+Screen.BOARD_X,
        board.piece[i].y*40+Screen.BOARD_Y,null);
    }
    
    // ֻؤסס֤פ˥ޥ
    for(int i=0;i<3;i++)
      g.drawImage(data.mask_g[1],Screen.BUTTON_X,Screen.BUTTON_Y+i*50,null);
    
    data.redraw = true;
    
  }



//
// execCommand : åäȤν򤹤
//
  public void execCommand(String message)
  {
    // ƬΥޥɤФ
    String command = getToken(message,0);
    
    if(data.cursor.mode >= 5)
      return;
    
    // ꤬ȿ§򤷤
    if(command.equals("ENEMYVIOLATE"))
    {
      // 饤դäƥåɽ
      board.enemyLife--;
      g.setColor(Color.black);
      g.fillRect(Screen.LIFE_X+13*board.enemyLife,Screen.LIFE_Y+90,13,13);
      
      g.copyArea(0,538,370,19,50,445-538);
      data.redraw = true;
    }

    // ʬȿ§򤷤
    if(command.equals("VIOLATE"))
    {
      // 饤դ
      board.myLife--;
      g.setColor(Color.black);
      g.fillRect(Screen.LIFE_X+13*board.myLife,Screen.LIFE_Y,13,13);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.copyArea(0,557,105,19,50,426-557);
      
      // ͳˤåʬ
      String violate = getToken(message,1);
      
      // Υޤӱۤ
      if(violate.equals("JUMPOVER"))
        g.copyArea(0,576,370,19,150,426-576);
      // 
      if(violate.equals("CHECK"))
        if(board.checked)
          g.copyArea(0,595,370,19,150,426-595);
        else
          g.copyArea(0,614,370,19,150,426-614);
      // Υޤξ֤
      if(violate.equals("DROPON"))
        g.copyArea(0,633,370,19,150,426-633);
      // Ǥͤ
      if(violate.equals("CHECKMATEBYDROPPINGPAWN"))
        g.copyArea(0,652,370,19,150,426-652);
      
      g.copyArea(370,614,370,19,50-370,445-614);
      
      // ILLEGAL 
      command = "ILLEGAL";
      
      data.redraw = true;
    }

    // ˰ܤ
    if(command.equals("OK"))
    {
      //// ޤºݤ˰ư
      // ư ID Υå
      board.setPieceId(data.cursor.to,data.cursor.checkedId);
      board.piece[data.cursor.checkedId].set(data.cursor.to);
      
      // ư ID Υå
      if(data.cursor.from.group == 0)
        board.setPieceId(data.cursor.from,0);
      if(data.cursor.from.group == 1)
      {
        int id;
        
        board.capPiece[board.getPieceKind(data.cursor.from) - 1] --;
        
        board.setPieceId(data.cursor.from,
		board.getNextPieceId(board.getPieceKind(data.cursor.from)));
      }
      
      // ޤäν
      board.piece[data.cursor.checkedId].kind += board.promote * 8;
      
      board.promote = 0;
      
      // ֤(åɽ)
      data.cursor.modeAndReset(4,g);
      
      g.setColor(Color.black);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.copyArea(0,519,370,19,50,-93);
      
      // ΥޤäΤʤ
      String getPiece = getToken(message,1);
      // γǧ
      for(int getKind=1;getKind<8;getKind++)
      if(getPiece.equals(Board.PIECENAME[getKind]))
      {
        // ޤ䤷ɽ
        board.capPiece[getKind - 1]++;
        
        g.drawImage(data.piece_g[getKind],Screen.CAP_X,
                                        Screen.CAP_Y+40*(getKind-1),null);
        
        g.setColor(Color.black);
        g.fillRect(Screen.CAP_X-20,Screen.CAP_Y+(getKind-1)*40,14,40);
        g.setFont(new Font("Helvetica",Font.BOLD,13));
        g.setColor(Color.yellow);
        g.drawString(Integer.toString(board.capPiece[getKind-1]),
            Screen.CAP_X-20,Screen.CAP_Y+(getKind-1)*40+40);
        
        // äޤ򤵤ˤƾɽ
        g.copyArea(513,515,140,17,400-513,425-515);
        g.drawImage(data.piece_g[getKind+16],540,425,null);
	int tmpX,tmpY;
	if(data.mySide == 1)
        {
	  tmpX = 8-data.cursor.to.x;
	  tmpY = 8-data.cursor.to.y;
	}
	else
        {
	  tmpX = data.cursor.to.x;
	  tmpY = data.cursor.to.y;
	}
        g.copyArea(513+(8-tmpX)*18,481,18,17,
                   500-(513+(8-tmpX)*18),445-481);
        g.copyArea(513+tmpY*18,498,18,17,
                   520-(513+tmpY*18),445-498);

        
        // ޤ ID Ĥƥå
        int tmpId = board.getNextPieceId(0);
        
        board.piece[tmpId].set(9,getKind-1,getKind);
        board.setPieceId(9,getKind-1,tmpId);
      }
      
      // ؤ褦
      if(getToken(message,1).equals("CHECK") ||
             getToken(message,2).equals("CHECK"))
        g.copyArea(210,557,145,19,240-210,-131);

      board.checked = false;
      data.redraw = true;
    }

    // ư˼ԤȤ
    if(command.equals("ILLEGAL"))
    {
      data.cursor.cancel(g,
                  board.capPiece[board.getPieceKind(data.cursor.from) - 1]);
      
      board.promote = 0;
      data.redraw = true;
    }

    // ʬ֤ޤäƤ
    if(command.equals("NEXT"))
    {
      data.cursor.modeAndReset(0,g);
      
      // åɽ
      g.setColor(Color.black);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.copyArea(0,481,370,38,50,-55);
      
      // ޤ줿
      if(!(getToken(message,2).equals("")))
      {
        int gottenX = 9-Integer.parseInt(getToken(message,1));
        int gottenY = Integer.parseInt(getToken(message,2))-1;
	
        // 줿ޤɽ
        g.copyArea(513,532,140,17,400-513,425-532);
        g.copyArea(513+(8-gottenX)*18,481,18,17,
                   500-(513+(8-gottenX)*18),445-481);
        g.copyArea(513+gottenY*18,498,18,17,
                   520-(513+gottenY*18),445-498);
	
        if(data.mySide == 1)
        {
          gottenX = 8 - gottenX;
          gottenY = 8 - gottenY;
        }
        
        g.drawImage(data.piece_g[board.getPieceKind(gottenX,gottenY)],
                    540,425,null);
        
        // פ饳ޤä
        g.copyArea(Screen.BLANK_X,Screen.BLANK_Y,39,39,
                   -Screen.BLANK_X+Screen.BOARD_X+gottenX*40,
                   -Screen.BLANK_Y+Screen.BOARD_Y+gottenY*40);
	
        int gottenId = board.id[gottenX][gottenY];
        
        board.piece[gottenId].set(9,9,0);
        board.setPieceId(gottenX,gottenY,0);
      }
      
      // ؤ줿
      if(getToken(message,1).equals("CHECKED") ||
         getToken(message,3).equals("CHECKED"))
      {
        g.copyArea(105,557,105,19,115,-131);
        board.checked = true;
      }
      
      board.promote = 0;
      data.redraw = true;
    }

    // 郎λ
    if(command.equals("END"))
    {
      // ̤Ⱦ()ͳɽ
      String state = getToken(message,1);
      
      g.setColor(Color.black);
      g.fillRect(220,180,200,120);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.setColor(Color.green);
      g.drawRect(220,180,200,120);
      
      if(state.equals("WIN"))
        g.copyArea(640,80,100,40,270-640,200-80);
      if(state.equals("LOSE"))
        g.copyArea(640,120,100,40,270-640,200-120);
      if(state.equals("DRAW"))
        g.copyArea(640,160,100,40,270-640,200-160);
      
      String reason = getToken(message,2);
      
      g.copyArea(370,541,50,15,230-370,270-541);
      
      if(reason.equals("GIVEUP"))
        g.copyArea(370,481,140,15,270-370,270-481);
      if(reason.equals("LOSELIFE"))
        g.copyArea(370,496,140,15,270-370,270-496);
      if(reason.equals("CHECKMATE"))
        g.copyArea(370,511,140,15,270-370,270-511);
      if(reason.equals("EMERGENCY"))
        g.copyArea(370,526,140,15,270-370,270-526);
      
      g.copyArea(0,671,370,19,50,426-671);
      
      // Ƹ⡼ɤ򸫤뤫ɤγǧ
      g.copyArea(370,557,370,19,50-370,445-557);
      
      g.copyArea(640,200,70,50,
                  Screen.QYESNO_X-640,Screen.QYESNO_Y-200);
      
      // ³Ԥ֤ˤƥåĤʤ
      data.connect.stop();
      
      data.cursor.modeAndReset(6,g);
      data.redraw = true;
    }
  }



//
// mainloop
//
  public int mainloop()
  {
    return(nextMode);
  }



//
// mouseDown : ޥ줿ν򤹤
//
  public boolean mouseDown()
  {

    // λܥ򲡤
    if(data.cursor.getGroup() == 4)
    {
      // ǧΥåФ
      g.setColor(Color.black);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.copyArea(370,576,370,38,50-370,426-576);
      g.copyArea(640,200,70,50,Screen.QYESNO_X-640,Screen.QYESNO_Y-200);
      data.cursor.modeAndReset(data.cursor.mode+5,g);
      data.redraw = true;
      
      return(true);
    }

    // Yes or No (λǤ)
    if(data.cursor.getGroup() == 3 && data.cursor.mode != 6)
    {
      // λ
      if(data.cursor.getY() == 0)
      {
        data.connect.sendMessage("GIVEUP");
        data.cursor.modeAndReset(4,g);
      }
      // λʤ
      else
        data.cursor.modeAndReset(data.cursor.mode-5,g);
      
      // å򸵤᤹
      g.setColor(Color.black);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      
      if(data.cursor.mode == 0)
        g.copyArea(0,481,370,38,50,-55);
      if(data.cursor.mode == 4)
        g.copyArea(0,519,370,19,50,-93);
      
      data.redraw = true;
      return(true);
    }

    // Yes or No (ｪλǤ)
    if(data.cursor.getGroup() == 3 && data.cursor.mode == 6)
    {
      data.cursor.modeAndReset(7,g);
      data.cursor.mouseOk = false;
      
      // åɽ
      g.setColor(Color.black);
      g.fillRect(Screen.MSGBOX_X,Screen.MSGBOX_Y,561,51);
      g.copyArea(370,671,370,19,50-370,436-671);
      
      // Ƹ⡼ɤ
      if(data.cursor.getY() == 0)
        nextMode = 5;
      
      // ƸϤʤ
      if(data.cursor.getY() == 1)
      {
        data.connect.flushMessages();
        nextMode = 0;
        data.connect.reopen();
      }
      
      data.redraw = true;
      return(true);
    }

    if(data.cursor.mode == 0)
    {
      // ׾ζor
      if((data.cursor.getGroup() == 0 && 
          board.getPieceId(data.cursor.curr) != 0) ||
         (data.cursor.getGroup() == 1 && 
          board.capPiece[data.cursor.getY()] != 0))
      {
	
        // ưǽΰõ moveTo ˳Ǽ
        for(int y=0;y<9;y++)
          for(int x=0;x<9;x++)
          {
	    Tpoint tmpTo = new Tpoint(0,x,y);
            if(board.getPieceId(tmpTo) == 0)
              board.moveTo[x][y] = board.moveCheck(
  		       board.getPieceId(data.cursor.curr),
                       data.cursor.curr,tmpTo);
	    else
	      board.moveTo[x][y] = 0;
	  }

        data.cursor.drag(g,board.getPieceId(data.cursor.curr),
                data.piece_g[board.getPieceKind(data.cursor.curr)],
                board.capPiece[board.getPieceKind(data.cursor.curr) - 1],
		board.moveTo);
        
        data.redraw = true;
      }
      return(true);
    }

    // ֻؤסס֤פ
    if(data.cursor.getGroup() == 2)
    {
      switch(data.cursor.getY())
      {
        // 
        case 1:
          if(!(board.moveThere >= 2 && 
               board.getPieceKind(data.cursor.checkedId) < 9))
            break;
          board.promote = 1;
          g.drawImage(data.piece_g[board.getPieceKind(data.cursor.checkedId)+
                                board.promote*8],
                      Screen.BOARD_X+data.cursor.to.x*40,
                      Screen.BOARD_Y+data.cursor.to.y*40,null);
          // Τޤ޲ν
        
        // ֻؤ
        case 0:
          if(board.moveThere == 3 && board.promote == 0)
            break;
          
          data.cursor.modeAndReset(3,g);
          data.redraw = true;
          
          for(int i=0;i<3;i++)
            g.drawImage(data.mask_g[1],Screen.BUTTON_X,Screen.BUTTON_Y+i*50,
                        null);
          
          // å
          String sendMsg = "";
          
          // ׾ˤ
          if(data.cursor.from.group == 0)
          {
            Tpoint tmpFrom,tmpTo;
            
            if(data.mySide == 0)
              sendMsg = "MOVE "+(9-data.cursor.from.x)+" "+
                                (1+data.cursor.from.y)+" "+
                                (9-data.cursor.to.x)+" "+(1+data.cursor.to.y);
            else
              sendMsg = "MOVE "+(1+data.cursor.from.x)+" "+
                                (9-data.cursor.from.y)+" "+
                                (1+data.cursor.to.x)+" "+(9-data.cursor.to.y);
            
            if(board.promote == 1)
              sendMsg = sendMsg + " PROMOTE";
            else
              sendMsg = sendMsg + " NOTPROMOTE";
          }
          
          // 
          if(data.cursor.from.group == 1)
          {
            if(data.mySide == 0)
              sendMsg = "DROP "+(9-data.cursor.to.x)+" "
                               +(1+data.cursor.to.y)+" "+
                               Board.PIECENAME[data.cursor.from.y + 1];
            else
              sendMsg = "DROP "+(1+data.cursor.to.x)+" "
                               +(9-data.cursor.to.y)+" "+
                               Board.PIECENAME[data.cursor.from.y + 1];
            
          }
          
          // MOVE or DROP 
          data.connect.sendMessage(sendMsg);
          break;
          
        
        // ֤
        case 2:
          data.cursor.cancel(g,
                  board.capPiece[board.getPieceKind(data.cursor.from) - 1]);
          for(int i=0;i<3;i++)
            g.drawImage(data.mask_g[1],Screen.BUTTON_X,Screen.BUTTON_Y+i*50,
                        null);
          
          board.promote = 0;
          data.redraw = true;
          break;
        
        default:
          break;
      }
      return(true);
    }
    return(false);
  }
  
//
// mouseUp : ޥΥ줿ν򤹤
//
  public boolean mouseUp()
  {
    // ޤưˤ뤫ǧ
    //    board.moveThere = board.moveCheck(data.cursor.checkedId,
    //                                      data.cursor.from,data.cursor.curr);
    board.moveThere = board.moveTo[data.cursor.getX()][data.cursor.getY()];
    
    if(board.getPieceId(data.cursor.curr) != 0 || board.moveThere == 0)
    {
      // ޤΰư˼
      data.cursor.failDrop(g,
                  board.capPiece[board.getPieceKind(data.cursor.from) - 1],
		  board.moveTo);
    }
    else
    {
      // ޤΰư
      data.cursor.safeDrop(g,board.moveTo);
      
      g.copyArea(640,Screen.BUTTON_Y+100,100,50,-140,0);
      if(board.moveThere >= 2)
        g.copyArea(640,Screen.BUTTON_Y+50,100,50,-140,0);
      if(board.moveThere == 1 || board.moveThere == 2)
        g.copyArea(640,Screen.BUTTON_Y,100,50,-140,0);
    }
    
    data.redraw = true;
    return(true);
  }


}
