/*****************************
 *   Ĥƾ for Java   *
 *****************************/

package tuitate_4_1_4;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;

//
// class TuitateShogi : ᥤȤʤ륯饹
//
public class TuitateShogi extends Applet implements Runnable
{
  // MediaTracker
  MediaTracker tracker;
  
  // å
  Thread th = null;

  // ֥Хåե󥰤ΤΥ᡼GC
  Image double_buffer;
  Graphics dg;

  //̹ޤǤΥ (msec)
  public final int WAITTIME = 50;

  //꡼礭(̤˽Ф礭ǤϤʤ) 
  public final int WIDTH = 740;
  public final int HEIGHT = 750;

  //¾Υ饹ȤǶͭǡΥ饹
  GameData data;

  //եȤɤ(ߤfalseǤʤ)
  boolean logOk = false;

  // ߤΥΥ⡼ɤȰܹԤ٤Υ⡼
  int gameMode = 0;
  int prevMode = 6;
  // Υ⡼
  Mode mode[] = new Mode[7];

  
//
// init : 
//
  public void init()
  {
    // ͭǡν
    data = new GameData(logOk);

    data.apc = getAppletContext();
    data.log.write("init() method processing ...");
    
    // ̤Υꥵ
    resize(Screen.X,Screen.Y);

    // ֥Хåե󥰤ν
    double_buffer = createImage(WIDTH,HEIGHT);
    dg = double_buffer.getGraphics();

    // ̤ν
    Screen.clear(dg);
    
    // ̤ɤ߹
    loadImage();
    
    // html file  servername,port ɤ߹
    // WindowsǤNetscapeǤϤޤʤ礬
    String server = getParameter("servername");
    int port = Integer.parseInt(getParameter("portnum"));
//  int port = 9070;
    // ФȤ³ν
    data.log.write("Server : "+server+"  Port : "+port);    
    data.connect = new Connection(server,port,data.log);
    
    data.myName = getParameter("name");
    data.myEmail = getParameter("email");
    
    // ⡼ɤν
    mode[0] = new NewtralMode(data,dg);
    mode[1] = new SelectEnemyMode(data,dg);
    mode[2] = new SelectGameMode(data,dg);
    mode[3] = new SelectNotationMode(data,dg);
    mode[4] = new GameMode(data,dg);
    mode[5] = new ViewMode(data,dg);
    
    // åɤν
    th = new Thread(this);
    th.start();

  }

  
//
// loadImage : Image ɤ߹
//
  public void loadImage()
  {
    // MediaTrackerȤ
    tracker = new MediaTracker(this);
    
    // ΤΥ᡼
    Image piece_all;
    ImageFilter cropfilter;
    // ޥΤ
    Image maskOrg;
    
    // ΤΥ᡼ɤ߹
    piece_all = getImage(getDocumentBase(),
		 "tuitate_"+data.version.replace('.','_')+"/piece.gif");
    
    // İĤζΥ᡼
    for(int i=0;i<32;i++)
    {
      int crop_x = (i % 4) * 40;
      int crop_y = (i / 4) * 40;
      cropfilter = new CropImageFilter(crop_x,crop_y,40,40);
      data.piece_g[i] = createImage(new FilteredImageSource
                           (piece_all.getSource(),cropfilter));
      tracker.addImage(data.piece_g[i],0);
    }
    
    // ޥ
    maskOrg = getImage(getDocumentBase(),
		       "tuitate_"+data.version.replace('.','_')+"/mask.gif");
    
    int x[] = {150,100,150,60};
    int y[] = {15,50,20,25};
    
    for(int i=0;i<4;i++)
    {
      cropfilter = new CropImageFilter(0,0,x[i],y[i]);
      data.mask_g[i] = createImage(new FilteredImageSource
                         (maskOrg.getSource(),cropfilter));
      tracker.addImage(data.mask_g[i],0);
    }
    
  }


//
// paint ᥽å
//
  public void paint(Graphics g)
  {
    g.drawImage(double_buffer,0,0,null);
  }

  public void update(Graphics g)
  {
    paint(g);
  }


//
// start : thread Υ
//
  public void start()
  {
    data.log.write("start() method processing ...");
  }


//
// destroy : Applet νλ
//
  public void destroy()
  {
    data.log.write("destroy() method processing ...");
    
    data.connect.close();
    data.log.close();
    th.stop();
    
    th = null;
  }


//
// handleEvent : ٥Ȥ
//
  public boolean handleEvent(Event evt)
  {
    // ޥȿ٤
    if(!data.cursor.mouseOk)
      return false;
    
    // ֤å
    data.cursor.point(evt.x,evt.y);
    
    // 뤬¸ߤ٤֤
    if(!data.cursor.possible(gameMode))
    {
      data.cursor.setGroup(-1);
    }
    
    switch(evt.id)
    {
     
      // 뤬ư
      case Event.MOUSE_MOVE:
        if(data.cursor.moved())
        {
          data.cursor.move(dg);
          data.redraw = true;
        }
        return true;
      
      // ޥ줿
      case Event.MOUSE_DOWN:
        if(data.cursor.getGroup() == -1)
          return false;
        return(mode[gameMode].mouseDown());
      
      
      // ܥΥ줿
      case Event.MOUSE_UP:
        if(data.cursor.mode != 1 || gameMode != 4)
          return false;
        return(mode[gameMode].mouseUp());
      
      
      // ޥɥå줿
      case Event.MOUSE_DRAG:
        if(gameMode == 4 && data.cursor.moved())
        {
          data.cursor.move(dg);
          data.redraw = true;
        }
        return true;

      // ޥ̳˽Ф
      case Event.MOUSE_EXIT:
        data.cursor.erase(dg);
	return true;
    }
    return false;
  }


//
// run : åɤμ¹ԥ롼
//
  public void run()
  {
    repaint();
    
    // ̤ɽ
    dg.setFont(new Font("Helvetica",Font.BOLD,35));
    dg.setColor(Color.white);
    dg.drawString("TUITATE SHOGI ver. "+data.version,120,150);
    
    dg.setFont(new Font("Helvetica",Font.BOLD,25));
    dg.setColor(Color.yellow);
    dg.drawString("Connecting to server ....",160,200);
    repaint();
    
    // Ф³
    if(!(data.connect.open()))
    {
      dg.setColor(Color.red);
      dg.drawString("Error : Cannot connect to server",160,250);
      repaint();
      th.stop();
    }
    
    dg.setColor(Color.green);
    dg.drawString("Connecting to server ....",160,200);
    dg.setColor(Color.yellow);
    dg.drawString("Loading Image ....",160,250);
    repaint();
    
    // ̤Υ
    try {
      tracker.waitForID(0);
    } catch(InterruptedException e) {
    }
    
    
    // ᥤ롼
    while(true)
    {
      String imageName[] = {"list","list","list","list",
                            "board","view","none"};
      
      // ཪλ
      if(gameMode == -1)
        endGame();
      
      // ̤ɤľ򤹤뤫
      if(!imageName[gameMode].equals(imageName[prevMode]))
      {
	if(prevMode != 6)
            data.screen.current.flush();
        data.screen.current = getImage(getDocumentBase(),
                           "tuitate_"+data.version.replace('.','_')+"/"+
                           imageName[gameMode]+".gif");
        tracker.addImage(data.screen.current,gameMode + 1);
        
        data.log.write("Image " + imageName[gameMode] + " Loading .....");
        data.apc.showStatus(imageName[gameMode]+".gif Loading ...");
        try {
          tracker.waitForID(gameMode + 1);
        } catch(InterruptedException e) {
        }
        data.apc.showStatus(imageName[gameMode]+".gif Loaded.");
        
        // ̤ν񤭴
        Screen.clear(dg);
        data.screen.draw(dg,gameMode);
      }

      // ⡼ɤν
      data.cursor.newBtnGrp(gameMode);      
      mode[gameMode].init();
      mode[gameMode].nextMode = gameMode;
      prevMode = gameMode;
      repaint();
      
      // ϤƳ
      data.cursor.mouseOk = true;
      
      while(true)
      {
       
        // Ԥ
        try {
          Thread.sleep(WAITTIME);
        } catch(InterruptedException e) {
          break;
        }
        
        if(data.connect.isOpen)
        {
          // åΤʤäƻؼ˽
          int getOk;
          try {
            getOk = data.connect.dataIn.available();
          } catch(IOException e) {
            getOk = 0;
          }
	  
          if(getOk > 0 && !data.connect.isWaiting)
            mode[gameMode].execCommand(data.connect.waitMessage());
        }
        
        gameMode = mode[gameMode].mainloop();
        
        // 褹뤫
        if(data.redraw)
        {
          repaint();
          data.redraw = false;
        }
        
        // ⡼ѹä
        if(gameMode != prevMode)
        {
          // Ϥػߤ
          data.cursor.mouseOk = false;
          data.cursor.modeAndReset(0,dg);
          break;
        }
      }
    }
  
  }


//
// stop : Applet ߤ
//
  public void stop()
  {
    data.log.write("stop() method processing ... ");
  }


//
// endGame : λ
//
  public void endGame()
  {
    Screen.clear(dg);
    dg.setColor(Color.white);
    dg.setFont(new Font("Helvetica",Font.BOLD,20));
    dg.drawString("Thank you for playing ...",400,470);
    
    data.log.write("GAME END");
    data.log.close();
    
    // ³μ
    data.connect.close();
    
    // åɤ
    th.stop();
    
    repaint();
  }
  
}
