/*
 *  Mode 5 : ViewMode                            01
 *    mode 0 : ̾ξ                        ox
 *    mode 1 : Υ⡼ɤλ뤫ɤ      xo
 *    mode 2 : Ԥ                          xx
 *  ButtonGroup 0 : ʤ᤿ᤷꤹܥ
 *              1 : Yes-No ܥ
 */

package tuitate_4_1_4;

import java.awt.*;

//
// class ViewMode : VIEW ⡼ɤ
//
public class ViewMode extends Mode
{
  //  (˴ؤǡ)
  Board board;

  // Ƹ⡼(0)⡼(1)⡼(2)
  int viewType;
  // ⡼
  boolean followMode;
  // ξ
  Hand currHand,lastHand,firstHand = null;

  // ɤޤǼʤ(᤹)
  int nextHandId;

//
// 󥹥ȥ饯
//
  public ViewMode(GameData _data,Graphics _g)
  {
    // ѡ饹Ʊ
    super(_data,_g);
  }
  
  
//
// init : 
//
  public void init()
  {
    // Version ɽ
    g.setColor(Color.yellow);
    g.setFont(new Font("Helvetica",Font.BOLD,10));
    g.drawString("ver. " + data.version,570,75);

    // 
    board = new Board();
    
    firstHand = new Hand();
    lastHand = currHand = firstHand;
    nextHandId = 1;
    
    // ⡼ɤϲ?
    if(data.checked.start != -1)
    {
      // ⡼      
      viewType = 2;
      data.mySide = 0;
      g.copyArea(110,560,110,20,520-110,35-560);
      followMode = false;
    }
    else if(data.checked.name2 != null)
    {
      // ⡼      
      viewType = 1;
      data.mySide = 0;
      g.copyArea(0,560,110,20,520,45-560);
      followMode = true;
      // ꥢ륿⡼
      g.copyArea(0,580,132,17,500-0,28-580);
    }
    else
    {
      // Ƹ⡼
      viewType = 0;      
      g.copyArea(220,560,110,20,520-220,35-560);
      followMode = false;
    }

    showCommandBox();

    // ΰưΥܥΥޥ
    if(viewType == 0 || viewType == 2)
      for(int i=1;i<4;i++)
	g.drawImage(data.mask_g[3],
	            Screen.COMBOX_X,Screen.COMBOX_Y+i*25,null);
    else
      for(int i=4;i<7;i++)
	g.drawImage(data.mask_g[3],
		    Screen.COMBOX_X,Screen.COMBOX_Y+i*25,null);
      
    
    //// ڤӸ̾ɽ
    // 
    String tmpStr;
    if(viewType == 0 && data.mySide == 0)
      tmpStr = data.myName;
    else
      tmpStr = data.checked.name1;
    putString(50,435,tmpStr,170,15);
    
    // 
    if(viewType == 0)
      if(data.mySide == 0)
        tmpStr = data.checked.name1;
      else
        tmpStr = data.myName;
    else
      tmpStr = data.checked.name2;
    putString(260,435,tmpStr,170,15);

    // ֲפֶ̾פ
    data.piece_g[8] = data.piece_g[13];
    data.piece_g[24] = data.piece_g[29];
    
    // ޤ֤
    for(int i=1;i<21;i++)
    {
      g.drawImage(data.piece_g[board.piece[i].kind],
                  board.piece[i].x*40+Screen.VBOARD_X,
                  board.piece[i].y*40+Screen.VBOARD_Y,null);
      board.piece[i+20].set(8-board.piece[i].x,
                           8-board.piece[i].y,board.piece[i].kind+16);
      board.setPieceId(board.piece[i+20].x,board.piece[i+20].y,i+20);
      g.drawImage(data.piece_g[board.piece[i+20].kind],
                  board.piece[i+20].x*40+Screen.VBOARD_X,
                  board.piece[i+20].y*40+Screen.VBOARD_Y,null);
    }
    
    // ȿ§Ĥɽ
    showLife(0,board.myLife,false);
    showLife(1,board.enemyLife,false);

    // ³Ԥ֤ʤ
    data.connect.start();

    if(data.mySide == 1)
    //   ,   ɽȿž롣
      for(int i=0;i<4;i++)
      {
	g.copyArea(Screen.VBOARD_X+i*40,Screen.VBOARD_Y-25,40,20,
		   600-Screen.VBOARD_X-i*40,600-Screen.VBOARD_Y+25);
	g.copyArea(Screen.VBOARD_X+(8-i)*40,Screen.VBOARD_Y-25,40,20,
		   (i-4)*80,0);
	g.copyArea(600,600,40,20,
		   Screen.VBOARD_X+(8-i)*40-600,Screen.VBOARD_Y-25-600);

	g.copyArea(Screen.VBOARD_X-25,Screen.VBOARD_Y+i*40,20,40,
		   600-Screen.VBOARD_X+25,600-Screen.VBOARD_Y-i*40);
	g.copyArea(Screen.VBOARD_X-25,Screen.VBOARD_Y+(8-i)*40,20,40,
		   0,(i-4)*80);
	g.copyArea(600,600,20,40,
		   Screen.VBOARD_X-25-600,Screen.VBOARD_Y+(8-i)*40-600);
      }
    
    data.redraw = true;
  }
  
  
//
// putString : ʸɽ
//
  void putString(int x,int y,String str,int lengthX,int lengthY)
  {
    g.setColor(Color.white);
    g.setFont(new Font("Helvetica",Font.BOLD,15));
    g.drawString(str,0,636);
    g.copyArea(0,625,lengthX,lengthY,x,y-625);
    g.setColor(Color.black);
    g.fillRect(0,625,640,15);
  }


//
// execCommand : åäȤν򤹤
//
  public void execCommand(String message)
  {
    // åؤξ
    // ȡο 15 ȤƤΤѹɬפ
    String command[] = new String[15];
    for(int i=0;i<10;i++)
    {
      command[i] = getToken(message,i);
    }
    
    // END  . ³ڤ
    if(command[0].equals(".") ||
       (command[0].equals("END") && viewType == 1))
      data.connect.shut();

    if(command[0].equals("."))
      return;

    if(data.mySide == 1)
      lastHand.add(command,true);
    else
      lastHand.add(command,false);
    
    lastHand = lastHand.next;
    
    if(followMode)
      nextHandId++;
    
    showCommandBox();
  }



//
// mainloop
//
  public int mainloop()
  {
    // ʤ(᤹)Ĥ
    int restId = 0;
    
    if(currHand.id != nextHandId)
    {
      // ʤ
      if(currHand.id < nextHandId)
      {
	nextHand();
	restId = nextHandId - currHand.id;
      }
      // ᤹
      else
      {
	prevHand();
	restId = currHand.id - nextHandId;
      }
      showNotation();
    }

    // Ȳʤ(᤹)٤ɽ
    if(restId != 0)
      data.apc.showStatus("Rest "+restId+" Hands ("+
			   currHand.id+"->"+nextHandId+") Please Wait...");
    // Ԥ֤
    else
    {
      data.apc.showStatus("");
      if(data.cursor.mode == 2)
        data.cursor.modeAndReset(0,g);
      showCommandBox();
    }

    return(nextMode);
  }



//
// mouseDown : ޥ줿ν򤹤
//
  public boolean mouseDown()
  {
    if(data.cursor.getGroup() == 0)
      switch(data.cursor.getY())
      {
        // ֽλ
        case 0:
          data.cursor.modeAndReset(1,g);
          // ǧΥå
          g.setColor(Color.black);
          g.fillRect(Screen.VMSGBOX_X,Screen.VMSGBOX_Y,192,66);
          g.copyArea(Screen.VENDMSG_X,Screen.VENDMSG_Y,120,38,
                     437-Screen.VENDMSG_X,425-Screen.VENDMSG_Y);
          g.copyArea(Screen.YESNOV_X,Screen.YESNOV_Y,70,50,
                     Screen.VQYESNO_X-Screen.YESNOV_X,
                     Screen.VQYESNO_Y-Screen.YESNOV_Y);
          data.redraw = true;
          break;
        // First
        case 1:
	  nextHandId = 1;
          break;
        // -10
        case 2:
	  nextHandId -= 10;
	  if(nextHandId < 1)
  	    nextHandId = 1;
          break;
        // -1
        case 3:
	  if(nextHandId != 1)
            nextHandId--;
          break;
        // +1
        case 4:
	  if(nextHandId != lastHand.id)
            nextHandId++;
          break;
        // +10
        case 5:
	  nextHandId += 10;
	  if(nextHandId > lastHand.id)
  	    nextHandId = lastHand.id;
          break;
        // Last
        case 6:
	  nextHandId = lastHand.id;
          break;
      }

    if(currHand.id != nextHandId)
      data.cursor.modeAndReset(2,g);

    // å¨ɽ
    if(nextHandId == lastHand.id)
      followMode = true;
    else  
      followMode = false;
    
    if(viewType == 1)	  
      if(nextHandId == lastHand.id)
      // ꥢ륿⡼
	g.copyArea(0,580,132,17,500-0,28-580);
      else
      {
        // դĤδ⡼
	g.setColor(Color.black);
	g.fillRect(500,28,132,17);
      }

    // ⡼ɤȴФɤ
    if(data.cursor.getGroup() == 1)
    {
      // Yes
      if(data.cursor.getY() == 0)
      {
        data.cursor.modeAndReset(2,g);
        data.connect.reopen();
        nextMode = 0;
        
        data.redraw = true;
      }
      // No
      if(data.cursor.getY() == 1)
      {
        data.cursor.modeAndReset(0,g);
        g.setColor(Color.black);
        g.fillRect(Screen.VMSGBOX_X,Screen.VMSGBOX_Y,192,66);
        data.redraw = true;
      }
    }
    
    return true;
  }



//
// nextHand : μɽ
//
  public void nextHand()
  {
    currHand = currHand.next;
    
    // åܥåΥꥢ
    g.setColor(Color.black);
    g.fillRect(Screen.VMSGBOX_X,Screen.VMSGBOX_Y,192,66);
    
    // å¸ߤʤ
    if(currHand.message == null)
      currHand.makeMsg(board,data.mySide);
    
    // ȿ§ξ
    if(currHand.reason != 0 && !currHand.gameEnd)
    {
      // ȿ§
      if(currHand.side == 0)
      {
        showLife(0,board.myLife,true);
        board.myLife--;
        showLife(1,board.enemyLife,false);
      }
      // ȿ§
      else
      {
        showLife(1,board.enemyLife,true);
        board.enemyLife--;
        showLife(0,board.myLife,false);
      }
      // ȿ§ɽ
      showViolate(currHand.reason);
      showHiliteOff(currHand.prev.to);
    }
    else
    {
      showLife(0,board.myLife,false);
      showLife(1,board.enemyLife,false);
      
      // νλ
      if(currHand.gameEnd)
      {
	showHiliteOff(currHand.prev.to);
	showGameEnd(currHand.side,currHand.reason);
      }
      // ޤư
      else if(currHand.from.group == 0)
      {
        // ޤä
        if(board.getPieceId(currHand.to) != 0)
        {
          // ޤ䤷ɽ
          board.capPiece[(currHand.GetPutPieceKind-1)%8 + currHand.side * 8]++;
          showCapPiece(currHand.side,currHand.GetPutPieceKind,
                      board.capPiece[(currHand.GetPutPieceKind-1)%8 + 
                                     currHand.side * 8]);
          
          // ưΥޤõ
          board.piece[board.getPieceId(currHand.to)].set(9,9,0);
        }
        
        // ޤư
        board.setPieceId(currHand.to,board.getPieceId(currHand.from));
        board.piece[board.getPieceId(currHand.from)].set(currHand.to);
        board.setPieceId(currHand.from,0);
        // ޤä
        board.piece[board.getPieceId(currHand.to)].kind += currHand.promote*8;

	// ưɽ
	showHiliteOff(currHand.prev.to);
        showMovePiece(currHand.from,currHand.to,board.getPieceKind(currHand.to));
	showHiliteOn(currHand.to);
      }
      // ޤ֤
      else
      {
        // ޤ򸺤餹
        board.capPiece[currHand.GetPutPieceKind + currHand.side * 8 - 1]--;
        
        // Ƥ ID õ
        int tmpId = board.getNextPieceId(0);
        
        showCapPiece(currHand.side,currHand.GetPutPieceKind,
            board.capPiece[currHand.GetPutPieceKind + currHand.side * 8 - 1]);
        
        // ޤ򥻥å
        board.setPieceId(currHand.to,tmpId);
        board.piece[tmpId].set(currHand.to,
            currHand.GetPutPieceKind + (data.mySide + currHand.side)%2 * 16);
	
        // ɽ
	showHiliteOff(currHand.prev.to);
        g.drawImage(data.piece_g[currHand.GetPutPieceKind+
                                 (data.mySide+currHand.side)%2*16],
                     Screen.VBOARD_X+currHand.to.x*40,
                     Screen.VBOARD_Y+currHand.to.y*40,null);
	showHiliteOn(currHand.to);
      }
      
    }
    
    // ꤫ɤɽ
    showCheck(currHand.check);
    
    data.redraw = true;
    
  }



//
// prevHand : μɽ
//
  public void prevHand()
  {
    Hand hand = currHand;
    boolean dontMove = false;
    
    currHand = currHand.prev;
    
    // åܥåΥꥢ
    g.setColor(Color.black);
    g.fillRect(Screen.VMSGBOX_X,Screen.VMSGBOX_Y,192,66);
    
    // μȿ§ä
    if(hand.reason != 0 && !hand.gameEnd)
    {
      dontMove = true;
      
      if(hand.side == 0)
        board.myLife++;
      else
        board.enemyLife++;
    }
    
    // ꤫ɤɽ
    showCheck(currHand.check);
    
    data.redraw = true;
    
    // ȿ§ä
    if(currHand.reason != 0)
    {
      // ȿ§
      if(currHand.side == 0)
      {
        showLife(0,board.myLife+1,true);
        showLife(1,board.enemyLife,false);
      }
      // ȿ§
      else
      {
        showLife(1,board.enemyLife+1,true);
        showLife(0,board.myLife,false);
      }
      // ȿ§ɽ
      showViolate(currHand.reason);
    }
    else
    {
      // ȿ§ʤ
      showLife(0,board.myLife,false);
      showLife(1,board.enemyLife,false);
    }
    
    // ｪλ,ȿ§ϥޤΰưϤʤ
    if(hand.gameEnd || dontMove)
    {
      if(currHand.reason == 0)
        showHiliteOn(hand.prev.to);
      return;
    }
    
    // ޤư -()-> ޤդ˰ư
    if(hand.from.group == 0)
    {
      // ޤư
      board.setPieceId(hand.from,board.getPieceId(hand.to));
      board.piece[board.getPieceId(hand.to)].set(hand.from);
      board.setPieceId(hand.to,0);
      
      // ޤäƤ餽Υޤ򸵤᤹
      board.piece[board.getPieceId(hand.from)].kind -= hand.promote*8;
      
      // ޤΰưɽ
      showHiliteOff(hand.to);
      showMovePiece(hand.to,hand.from,board.getPieceKind(hand.from));
      if(currHand.reason == 0)
        showHiliteOn(hand.prev.to);
      
      // ޤä -()-> ޤ֤
      if(hand.GetPutPieceKind != 0)
      {
        // ޤ򸺤餹	
        board.capPiece[(hand.GetPutPieceKind-1)%8 + hand.side * 8 ]--;
        
        // Ƥ ID õ
        int tmpId = board.getNextPieceId(0);

        // ()ޤɽ
        g.drawImage(data.piece_g[hand.GetPutPieceKind+
                                 (1+data.mySide+hand.side)%2*16],
                                 Screen.VBOARD_X+hand.to.x*40,
                                 Screen.VBOARD_Y+hand.to.y*40,null);
        
        // ޤοɽ
        showCapPiece(hand.side,hand.GetPutPieceKind,
            board.capPiece[(hand.GetPutPieceKind-1)%8 + hand.side * 8]);
        
        // ()ޤ򥻥å
        board.setPieceId(hand.to,tmpId);

        board.piece[tmpId].set(hand.to,
            hand.GetPutPieceKind + (1 + data.mySide + hand.side)%2 * 16);

      }
    }
    // ޤ֤ -()->ޤ
    else
    {
      // ޤ䤷ɽ
      board.capPiece[hand.GetPutPieceKind + hand.side * 8 - 1]++;
      
      // ưΥޤõ
      board.piece[board.getPieceId(hand.to)].set(9,9,0);
      board.setPieceId(hand.to,0);

      // ޤΰưɽ
      showCapPiece(hand.side,hand.GetPutPieceKind,
                  board.capPiece[hand.GetPutPieceKind + hand.side * 8 - 1]);

      g.copyArea(Screen.VBLANK_X,Screen.VBLANK_Y,39,39,
                 Screen.VBOARD_X+hand.to.x*40-Screen.VBLANK_X,
                 Screen.VBOARD_Y+hand.to.y*40-Screen.VBLANK_Y);
      
      if(currHand.reason == 0)
        showHiliteOn(hand.prev.to);
    }
    
  }
  
  
//
// showLife : ȿ§λĤɽ
//
  void showLife(int side,int lifes,boolean lastRed)
  {
    g.setColor(Color.black);
    g.fillRect(Screen.VLIFE_X+210*side,Screen.VLIFE_Y,110,13);
    
    if(lifes <= 0)
      return;
    
    g.setColor(Color.white);    
    for(int i=0;i<lifes;i++)
      g.fillOval(Screen.VLIFE_X+210*side+13*i,Screen.VLIFE_Y,13,13);
    
    if(lastRed)
    {
      g.setColor(Color.red);
      g.fillOval(Screen.VLIFE_X+210*side+13*(lifes-1),Screen.VLIFE_Y,13,13);
    }
  }


//
// showViolate : ȿ§˴ؤɽ
//
  void showViolate(int reason)
  {
    // ȿ§
    g.copyArea(181,545,32,15,Screen.VMSGBOX_X-181,Screen.VMSGBOX_Y+51-545);
    
    // ͳɽ
    int reasonX[] = {0,101,261,421,549,629};
    g.copyArea(reasonX[reason],530,reasonX[reason + 1]-reasonX[reason],15,
               Screen.VMSGBOX_X+32-reasonX[reason],Screen.VMSGBOX_Y+51-530);
  }


//
// showGameEnd : ｪλ˴ؤɽ
//
  void showGameEnd(int side,int reason)
  {
    // סָס֤Ρ
    if(reason != 4)
    {
      int rX = 101+32*((side + reason) % 2);
      
      g.copyArea(rX,545,32,15,Screen.VMSGBOX_X-rX,Screen.VMSGBOX_Y+51-545);
      g.copyArea(165,545,16,15,
		 Screen.VMSGBOX_X+32-165,Screen.VMSGBOX_Y+51-545);
    }
    
    int reasonX[] = {0,181,325,357,389,485};
    // ͳɽ
    g.copyArea(reasonX[reason],545,reasonX[reason + 1]-reasonX[reason],15,
               Screen.VMSGBOX_X+48-reasonX[reason],Screen.VMSGBOX_Y+51-545);
  }


//
// showCapPiece : ޤɽ
//
  void showCapPiece(int side,int kind,int num)
  {
    // äޤ
    kind = kind % 8;

    int viewSide = (data.mySide + side)%2;
    
    int capX = Screen.VCAP_X[viewSide];
    int capY = Screen.VCAP_Y[viewSide];

    if(viewSide == 0)
      capY += (kind - 1)*40;
    else
      capY += (6 - (kind - 1))*40;
    
    g.setColor(Color.black);
    g.fillRect(capX-20,capY,14,40);
    
    // ޤο 0 ʳ
    if(num != 0)
    {
      g.drawImage(data.piece_g[kind + viewSide * 16],
                  capX,capY,null);
      
      g.setFont(new Font("Helvetica",Font.BOLD,13));
      g.setColor(Color.yellow);
      g.drawString(num+" ",capX-20,capY+40);
    }
    // 0 ξ
    else
     g.copyArea(Screen.VBLANK_X,Screen.VBLANK_Y,39,39,
                 capX-Screen.VBLANK_X,capY-Screen.VBLANK_Y);
    
  }


//
// showMovePiece : ޤΰưɽ
//
  void showMovePiece(Tpoint from,Tpoint to,int kind)
  {
    g.copyArea(Screen.VBLANK_X,Screen.VBLANK_Y,39,39,
               Screen.VBOARD_X+from.x*40-Screen.VBLANK_X,
               Screen.VBOARD_Y+from.y*40-Screen.VBLANK_Y);
    
    g.copyArea(Screen.VBLANK_X,Screen.VBLANK_Y,39,39,
               Screen.VBOARD_X+to.x*40-Screen.VBLANK_X,
               Screen.VBOARD_Y+to.y*40-Screen.VBLANK_Y);
    
    g.drawImage(data.piece_g[kind],Screen.VBOARD_X+to.x*40,
                                  Screen.VBOARD_Y+to.y*40,null);
  }


//
// showNotation : åɽ
//
  void showNotation()
  {
    //   󻰻͸ϻȬ˶̲Ʊξ
    // εľ  
    if(currHand.message != null)
    {
      for(int i=0;i<14;i++)
        g.copyArea((currHand.message[i]%25)*25+2,
                   (currHand.message[i]/25)*24+481,25,24,
                Screen.VMSGBOX_X+8+(i%7)*25-((currHand.message[i]%25)*25+2),
                Screen.VMSGBOX_Y+(i/7)*25-((currHand.message[i]/25)*24+481));
    }
  }



//
// showCheck : ꤫ɤɽ
//
  void showCheck(boolean flag)
  {
    // ξ
    if(flag)
      g.copyArea(450,481,50,24,15-450,360-481);
    else
    {
      g.setColor(Color.black);
      g.fillRect(15,360,50,24);
    }
  }
  

//
// showCommandBox : ʤ᤿ᤷꤹܥɽ
//
  public void showCommandBox()
  {
    // öä
    data.cursor.erase(g);

    g.copyArea(640,Screen.COMBOX_Y,60,175,Screen.COMBOX_X-640,0);
    // ȾΥޥ
    if(currHand.prev == null)
      for(int i=1;i<4;i++)
	g.drawImage(data.mask_g[3],
	            Screen.COMBOX_X,Screen.COMBOX_Y+i*25,null);
    // ȾΥޥ    
    if(currHand.next == null)
      for(int i=4;i<7;i++)
	g.drawImage(data.mask_g[3],
 	            Screen.COMBOX_X,Screen.COMBOX_Y+i*25,null);
      
    // Ƥӥɽ 
    data.cursor.draw(g);
  }

  
//
// showHiliteOn, showHiliteOff : ޤΰưοѤ
//  
  public void showHiliteOn(Tpoint pt)
  {
    if(pt.group == 0)
    {
      g.copyArea(Screen.VHILITE_X,Screen.VHILITE_Y,39,39,
                 -Screen.VHILITE_X+Screen.VBOARD_X+pt.x*40,
                 -Screen.VHILITE_Y+Screen.VBOARD_Y+pt.y*40);
      if(board.getPieceKind(pt) != 0)
	g.drawImage(data.piece_g[board.getPieceKind(pt)],
		    Screen.VBOARD_X+pt.x*40,Screen.VBOARD_Y+pt.y*40,null);
    }
  }
  
  public void showHiliteOff(Tpoint pt)
  {
    if(pt.group == 0)
    {
      g.copyArea(Screen.VBLANK_X,Screen.VBLANK_Y,39,39,
		 -Screen.VBLANK_X+Screen.VBOARD_X+pt.x*40,
		 -Screen.VBLANK_Y+Screen.VBOARD_Y+pt.y*40);
      if(board.getPieceKind(pt) != 0)
	g.drawImage(data.piece_g[board.getPieceKind(pt)],
		    Screen.VBOARD_X+pt.x*40,Screen.VBOARD_Y+pt.y*40,null);
    }
  }
  
}
