#!/bin/sh
### Tuitate for Java (easy?) Installer
### 97/11/18 T.Hagawa

### Please edit if you want to change ...

PREFIX="/usr/local"
TUITATEDIR=${PREFIX}"/lib/tuitated"
EXPORTDIR=${TUITATEDIR}"/export"

VERSION="4_1_4"
TUITATEVER="tuitate_"${VERSION}
CLASSDIR=${EXPORTDIR}"/"${TUITATEVER}
MANDIR=${EXPORTDIR}"/manual"

### Is 'tuitated' directory exist ?

if [ -d ${EXPORTDIR} ]
then
    echo "install HTML files ..."
    install -m 644 loader.html tuitate.html ${EXPORTDIR}
    echo "install class files ..."
    mkdir -p ${CLASSDIR}
    install -m 644 ${TUITATEVER}/*.class *.gif ${CLASSDIR}
    echo "install manual files ..."
    mkdir -p ${MANDIR}
    mkdir -p ${MANDIR}/image
    install -m 644 manual/*.html ${MANDIR}
    install -m 644 manual/image/*.gif ${MANDIR}/image
    echo "install completed."
else
    echo "Error : Cannot find tuitated export directory !!"
fi
