package tuitate_4_1_4;

import java.awt.*;

//
// class ButtonGroup : ܥ󷲤Υ饹
//
public class ButtonGroup
{

  // ΰ
  int x,y;
  // ܥ󷲤礭
  int lengthX,lengthY;
  // ܥĤ礭
  int buttonX,buttonY;
  // Υ᡼(ްư)
  Image cursorImg;
  // ˡ
  int style;
  
//
// 󥹥ȥ饯
//
  public ButtonGroup(int _x,int _y,int _lX,int _lY,
                     int _bX,int _bY,int _sty)
  {
    x = _x;
    y = _y;
    lengthX = _lX;
    lengthY = _lY;
    buttonX = _bX;
    buttonY = _bY;
    style = _sty; 
  }

//
// inGroup : ޥ뤬Υܥ󷲤ˤ뤫Ƚꤹ
//
  public Point inGroup(int mouseX,int mouseY)
  {
    Point location;
    
    if(mouseX >= x && mouseX < x + lengthX &&
       mouseY >= y && mouseY < y + lengthY)
    {
      location = new Point((mouseX - x) / buttonX,(mouseY - y) / buttonY);
    }
    else
      location = new Point(-1,-1);
    
    return(location);
  }
  

//
// drawBox : ܥβλͳѤ (᥽å)
//
  void drawBox(int cursorX,int cursorY,Graphics g,Color col)
  {
    g.setColor(col);
    g.drawRect(x-1+cursorX*buttonX,y-1+cursorY*buttonY,buttonX,buttonY);
  }
  
//
// draw : 
//
  public void draw(Tpoint cur,Graphics g,boolean pieceMove)
  {
    draw(cur.x,cur.y,g,pieceMove);
  }
  
  public void draw(int cursorX,int cursorY,Graphics g,boolean pieceMove)
  {
    switch(style)
    {
      // ̤
      case 0:
        this.drawBox(cursorX,cursorY,g,Color.white);
        break;
      
      // ԥꥹȤξ,ꥹȤξ	
      case 1:
        g.copyArea(445,710,20,20,Screen.LIST_X+cursorX*buttonX+5-445,
                   Screen.LIST_Y+cursorY*buttonY+5-710);
        break;
      
      // פξ : ޤưƤ뤫ɤǽѤ
      case 2:
        if(pieceMove)
        {
          g.copyArea(Screen.BOARD_X+cursorX*40+5,Screen.BOARD_Y+cursorY*40-5,
                     40,40,
                     660-(Screen.BOARD_X+cursorX*40+5),
                     -(Screen.BOARD_Y+cursorY*40-5));
          g.drawImage(cursorImg,
                      cursorX*40+Screen.BOARD_X+5,
                      cursorY*40+Screen.BOARD_Y-5,null);
        }
        else
          this.drawBox(cursorX,cursorY,g,Color.white);
        break;
      
      // ξ : ޤưƤ뤫ɤǽѤ
      case 3:
        if(pieceMove)
        {
          g.copyArea(Screen.CAP_X+5,Screen.CAP_Y+cursorY*40-5,40,40,
                     660-(Screen.CAP_X+5),-(Screen.CAP_Y+cursorY*40-5));
          g.drawImage(cursorImg,Screen.CAP_X+5,Screen.CAP_Y-5+cursorY*40,null);
        }
        else
          g.copyArea(642,0,15,15,-642+408,110+cursorY*40);
        break;
      
      default:
        break;
    }
  }


//
// erase : ä
//
  public void erase(Tpoint cur,Graphics g,boolean pieceMove)
  {
    erase(cur.x,cur.y,g,pieceMove);
  }
  
  public void erase(int cursorX,int cursorY,Graphics g,boolean pieceMove)
  {
    switch(style)
    {
      // ̤
      case 0:
        this.drawBox(cursorX,cursorY,g,Color.black);
        break;
      
      // ԥꥹȤξ,
      case 1:	
	g.copyArea(470,710,20,20,Screen.LIST_X+cursorX*buttonX+5-470,
                             Screen.LIST_Y+cursorY*buttonY+5-710);
        break;
      
      // פξ : ޤưƤ뤫ɤǽѤ
      case 2:
        if(pieceMove)
          g.copyArea(660,0,40,40,
                     -660+Screen.BOARD_X+cursorX*40+5,
                     Screen.BOARD_Y+cursorY*40-5);
        else
          this.drawBox(cursorX,cursorY,g,Color.black);
        break;
        
      // ξ : ޤưƤ뤫ɤǽѤ
      case 3:
        if(pieceMove)
          g.copyArea(660,0,40,40,
                     -660+Screen.CAP_X+5,Screen.CAP_Y+cursorY*40-5);
        else
        {
          g.setColor(Color.black);
          g.fillRect(408,110+cursorY*40,15,15);
        }
        break;
      
      default:
        break;
    }
  }

}
