package tuitate_4_1_4;

import java.awt.*;
import java.awt.image.*;

//
// class InputWindow : ̾ϥɥΥ饹
//
public class InputWindow extends Frame
{
  
  // ̾ & E-mailϥե
  TextField nameField,emailField;
  String name,email;
  
  // ܥ(OK,Cancel)
  Button okButton,noButton;
  
  // ƥȤФ
  TextCanvas tmp;
  
  // ܥ֤ΤΤ
  GridBagLayout gb = new GridBagLayout();
  GridBagConstraints gbc = new GridBagConstraints();
  
  // ѹäɤ
  boolean changed = false;


//
// 󥹥ȥ饯
//
  public InputWindow(String defaultName,String defaultEmail)
  {
    name = defaultName;
    email = defaultEmail;
    
    // ȥȥ쥤Ȥ
    setTitle("Enter your name");
    setBackground(Color.black);
    
    setLayout(gb);
    gbc.fill = GridBagConstraints.BOTH;
    gbc.insets = new Insets(5,10,5,10);
    
    tmp = new TextCanvas(" ",40,20,Color.white,20);
    setParts(0,0,1,1,tmp);
    setParts(0,3,1,1,tmp);
    setParts(3,3,1,1,tmp);
    
    setParts(0,0,6,1,new TextCanvas(
      "Please Enter your Name & E-mail Address",400,30,Color.red,20));
    
    // ̾ & E-mail եɤΥå
    setParts(0,1,2,1,new TextCanvas("Name :",55,30,Color.white,15));
    nameField = new TextField(name,30);
    setParts(2,1,4,1,nameField);
    nameField.setBackground(Color.gray);
    
    setParts(0,2,2,1,new TextCanvas("E-mail :",55,30,Color.white,15));
    emailField = new TextField(email,30);
    setParts(2,2,4,1,emailField);
    emailField.setBackground(Color.gray);
    
    // OK & Cancel ܥΥå
    okButton = new Button("OK");
    setParts(2,3,1,1,okButton);
    okButton.setFont(new Font("Helvetica",Font.BOLD,17));
    okButton.setBackground(Color.blue);
    okButton.setForeground(Color.white);
    
    noButton = new Button("Cancel");
    setParts(4,3,1,1,noButton);
    noButton.setFont(new Font("Helvetica",Font.BOLD,17));
    noButton.setBackground(Color.red);
    noButton.setForeground(Color.white);

    // ꤷľƤ
    name = setText(nameField);
    email = setText(emailField);
    
    // Ƥ򥻥å
    pack();
  }



//
// action : ٥Ȥ
//
//** return 򲡤ȤνϤɤʤäƤΤ?
  public boolean action(Event evt,Object arg)
  {
    if(evt.target instanceof Button)
    {
      // OK ܥ󤬲줿
      if("OK".equals(arg))
      {
        // ɥ򱣤
        this.hide();
        // ʸ
	email = setText(emailField);
        name = setText(nameField);
        changed = true;
        return true;
      }
      
      // Cancel ܥ󤬲줿
      else if("Cancel".equals(arg))
      {
        // ɥ򱣤	
        this.hide();
        // ʸ򸵤᤹	
        email = resetText(emailField,email);
        name = resetText(nameField,name);
        changed = true;
        return true;
      }
    }
    return false;
  }



//
// setText : եɤʸ
//
  String setText(TextField field)
  {
    String param;
    param = field.getText();
    // ' '  '_' Ѥ
    param = param.replace(' ','_');
    // ʸ󤬤ʤʤ'Unknown'ˤʤ
    if(param.equals(""))
      param = "Unknown";
    // ʸĹ64Byteޤ
    if(param.length() > 64)
      param = param.substring(0,64);
    // եʸꤹ
    field.setText(param);
    return(param);
  }



//
// resetText : եɤʸ򸵤᤹
//
  String resetText(TextField field,String param)
  {
    // ʸ󤬤ʤʤ'Unknown'ˤʤ
    if(param.equals(""))
      param = "Unknown";
    // եʸꤹ
    field.setText(param);
    return(param);
  }



//
// setParts : ܥʤɤ֤
//
  void setParts(int x,int y,int w,int h,Component cp)
  {
    gbc.gridx = x;
    gbc.gridy = y;
    gbc.gridwidth = w;
    gbc.gridheight = h;
    gb.setConstraints(cp,gbc);
    add(cp);
  }
  
}



//
// class TextCanvas : ƥȤ Canvas  class
//
class TextCanvas extends Canvas
{
  // ʸ礭,
  String str;
  int Xsize,Ysize,fontSize;
  Color col;



//
// 󥹥ȥ饯
//
  public TextCanvas(String s,int x,int y,Color c,int fs)
  {
    str = s;
    Xsize = x;
    Ysize = y;
    col = c;
    fontSize = fs;
    // Canvas 礭Ѥ
    resize(Xsize,Ysize);
  }


//
// paint : 
//
  public void paint(Graphics g)
  {
    // ȥեȤꤷʸ
    g.setColor(col);
    g.setFont(new Font("Helvetica",Font.BOLD,fontSize));
    g.drawString(str,0,Ysize-5);
  }
}

